var mongoose = require('mongoose');

//Doctor Schema

var doctorSchema = mongoose.Schema({
    name: {
    type:String
    },
    lastname1: {
    type:String
    },
    lastname2: {
    type:String
    },
    email: {
    type:String
    },
    password: {
    type:String
    },
    specialty: {
    type:String
    },
    dateOfBirth: {
    type:String
    }
    
});

var Doctor = module.exports = mongoose.model('Doctor', doctorSchema);

//Get doctors
module.exports.getDoctors = function(callback, limit) {
    Doctor.find().exec(callback);
}

//login doctor
module.exports.loginDoctor = function(data, callback) {
    Doctor.findOne(data).exec(callback);
}
//Get doctor by email
module.exports.getDoctorByEmail = function(emailid, callback) {
    Doctor.findOne(emailid).exec(callback);
}

//Get doctor by id
module.exports.getDoctorById = function(id, callback) {
    Doctor.findById(id).exec(callback);
}

//store doctor
module.exports.addDoctor = function(doctor, callback) {
    Doctor.create(doctor, callback);
}

//update doctor
module.exports.updateDoctor = function(id, doctor, options, callback) {
    var query = {_id:id};
    var update = {
        name: doctor.name,
        lastname1: doctor.lastname1,
        lastname2: doctor.lastname2,
        email: doctor.email,
        password: doctor.password,
        specialty: doctor.specialty,
        dateOfBirth: doctor.dateOfBirth
    }
    Doctor.findOneAndUpdate(query, update, options, callback);
}
