var mongoose = require('mongoose');

//Pacient Schema

var pacientSchema = mongoose.Schema({
    name: {
    type:String
    },
    lastname1: {
    type:String
    },
    lastname2: {
    type:String
    },
    email: {
    type:String
    },
    password: {
    type:String
    },
    medicines: {
    type:String
    },
    allergies: {
    type:String
    },
    surgeries: {
    type:String
    },
    dateOfBirth: {
    type:String
    },
    weight: {
    type:String
    },
    height: {
    type:String
    },
    diseases: {
    type:String
    },
    comments: {
    type:String
    }
});

var Pacient = module.exports = mongoose.model('Pacient', pacientSchema);

module.exports.getPacients = function(callback) {
    console.log(Pacient);
    Pacient.find().exec(callback);
}

//login pacient
module.exports.loginPacient = function(data, callback) {
    Pacient.findOne(data).exec(callback);
}

//Get pacient by email
module.exports.getPacientByEmail = function(emailid, callback) {
    Pacient.findOne(emailid).exec(callback);
}

//Get pacient by id
module.exports.getPacientById = function(id, callback) {
    Pacient.findById(id).exec(callback);
}

//store pacient
module.exports.addPacient = function(pacient, callback) {
    Pacient.create(pacient, callback);
}

//update pacient
module.exports.updatePacient = function(id, pacient, options, callback) {
    var query = {_id:id};
    var update = {
        name: pacient.name,
        lastname1: pacient.lastname1,
        lastname2: pacient.lastname2,
        email: pacient.email,
        password: pacient.password,
        medicines: pacient.medicines,
        allergies: pacient.allergies,
        surgeries: pacient.surgeries,
        dateOfBirth: pacient.dateOfBirth,
        weight: pacient.weight,
        height: pacient.height,
        diseases: pacient.diseases,
        comments: pacient.comments
    }
    Pacient.findOneAndUpdate(query, update, options, callback);
}