var express = require('express');
var app = express();
var bodyParser = require('body-parser');
var mongoose = require('mongoose');
const nodemailer = require('nodemailer');

app.use(bodyParser.json());

Doctor = require('./Models/doctor');
Pacient = require('./Models/pacient');
Specialty = require('./Models/specialty');
Wait = require('./Models/waitList');
Appointment = require('./Models/appointment');
Rate = require('./Models/rate');

// connect to mongoose
//mongoose.connect('mongodb://localhost/tfmehealth');
mongoose.connect('mongodb://alex:madrid2018@ds247330.mlab.com:47330/tfmehealth')
var db = mongoose.connection;

app.get('/', function(req,res){
    res.send('Please use /api/endpoint_name');
});

/*
****************************************************
START DOCTOR ENDPOINTS
****************************************************
*/

/*
DOCTOR SIGNUP endpoint
*/
app.post('/api/doctor/signup',function(req,res){
    var doctor = req.body;
    Doctor.addDoctor(doctor, function(err, doctor){
        if(err) {
            throw err;
        }
        
        res.json(doctor)
    });
});

/*
DOCTOR LOGIN endpoint
*/
app.post('/api/doctor/login',function(req,res){
    var doctor = req.body;
    console.log(doctor.email);
    var data = {email: doctor.email}
    Doctor.getDoctorByEmail(data,function(err, doctors){
        if(err) {
            throw err;
        }
        
        res.json(doctors)
    });
});

/*
DOCTOR GET DATA endpoint
*/
app.get('/api/:id/doctor_profile_data',function(req,res){
    console.log(req.params.id);
    Doctor.getDoctorById(req.params.id, function(err, doctor) {
        if(err) {
            throw err;
        }
        console.log(doctor);
        res.json(doctor);
    })
});

/*
DOCTOR UPDATE DATA endpoint
*/
app.put('/api/:id/doctor/update_doctor_profile_data',function(req,res){
    var id = req.params.id;
    var doctor = req.body;
    Doctor.updateDoctor(id, doctor, {},function(err, doctor){
        if(err) {
            throw err;
        }
        
        res.json(doctor)
    });
});


/*
DOCTOR RECOVER PASSWORD endpoint
*/
app.post('/api/doctor/recover_password',function(req,res){

    var pacient = req.body;
    var data = {email: pacient.email}
        
    Doctor.getDoctorByEmail(data,function(err, doctor){
        if(err) {
            throw err;
        }
        var transporter = nodemailer.createTransport({
        service: 'gmail',
        auth: {
            user: 'lycan.development@gmail.com',
            pass: 'Alex17983929'
        }
        });
        
        let mailOptions = {
        from: 'lycan.development@gmail.com', // sender address
        to: 'alexander.cabezas.m@gmail.com', // list of receivers
        subject: 'Recover password', // Subject line
        text: 'Your password is ' + doctor.password, // plain text body
        html: '<b>Your password is '+ doctor.password + '</b>' // html body
    };
    
    transporter.sendMail(mailOptions, (error, info) => {
        if (error) {
            return console.log(error);
        }
        console.log('Message sent: %s', info.messageId);
        // Preview only available when sending through an Ethereal account
        console.log('Preview URL: %s', nodemailer.getTestMessageUrl(info));

        // Message sent: <b658f8ca-6296-ccf4-8306-87d57a0b4321@example.com>
        // Preview URL: https://ethereal.email/message/WaQKMgKddxQDoou...
    });
        
        res.json({
	       "result": "ok"
            });
    });
    
    
    
});


/*
GET PACIENT IN WAIT LIST endpoint
*/
app.get('/api/doctor/get_user_waitlist',function(req,res){
    Wait.getWaitList(function(err, pacient){
        if(err) {
            throw err;
        }
        
        res.json({pacients:pacient})
    });
});

/*
GET SCHEDULED APPOINTMENTS
*/

app.get('/api/doctor/:id/scheduled_appointments',function(req,res){
    Appointment.getAppointmentList(function(err, appointment) {
        if(err) {
            throw err;
        }
        console.log(appointment);
        res.json({appointments:appointment});
    })
});


/*
****************************************************
END DOCTOR ENDPOINTS
****************************************************
*/



/*
****************************************************
START PACIENT ENDPOINTS
****************************************************
*/
/*
GET DOCTORS endpoint
*/
app.get('/api/doctors',function(req,res){
    Doctor.getDoctors(function(err, doctors){
        if(err) {
            throw err;
        }
        
        res.json({doctors:doctors})
    });
});

/*
GET SPECIALTIES endpoint
*/
app.get('/api/specialties',function(req,res){
    Specialty.getSpecialties(function(err, specialties){
        if(err) {
            throw err;
        }
        
        res.json({specialties:specialties})
    });
});
/*
PACIENT SIGNUP endpoint
*/
app.post('/api/signup',function(req,res){
    console.log(Pacient);
    console.log(req.body);
    var pacientR = req.body;
    Pacient.addPacient(pacientR, function(err, pacient){
        if(err) {
            throw err;
        }
        
        res.json(pacient)
    });
});

/*
PACIENT LOGIN endpoint
*/
app.post('/api/login',function(req,res){
    var pacient = req.body;
    console.log(pacient.email);
    var data = {email: pacient.email, password: pacient.password}
    Pacient.getPacientByEmail(data,function(err, pacient){
        if(err) {
            throw err;
        }
        
        res.json(pacient)
    });
});

/*
PACIENT RECOVER PASSWORD ENDPOINT
*/
app.post('/api/recover_password',function(req,res){

    var pacient = req.body;
    var data = {email: pacient.email}
        
    Pacient.getPacientByEmail(data,function(err, pacient){
        if(err) {
            throw err;
        }
        var transporter = nodemailer.createTransport({
        service: 'gmail',
        auth: {
            user: 'lycan.development@gmail.com',
            pass: 'Alex17983929'
        }
        });
        
        let mailOptions = {
        from: 'lycan.development@gmail.com', // sender address
        to: 'alexander.cabezas.m@gmail.com', // list of receivers
        subject: 'Recover password', // Subject line
        text: 'Your password is ' + pacient.password, // plain text body
        html: '<b>Your password is '+ pacient.password + '</b>' // html body
    };
    
    transporter.sendMail(mailOptions, (error, info) => {
        if (error) {
            return console.log(error);
        }
        console.log('Message sent: %s', info.messageId);
        // Preview only available when sending through an Ethereal account
        console.log('Preview URL: %s', nodemailer.getTestMessageUrl(info));

        // Message sent: <b658f8ca-6296-ccf4-8306-87d57a0b4321@example.com>
        // Preview URL: https://ethereal.email/message/WaQKMgKddxQDoou...
    });
        
        res.json({
	       "result": "ok"
            });
    });
    
    
    
});

/*
GET PACIENT DATA ENDPOINT
*/
app.get('/api/:id/user_profile_data',function(req,res){
    Pacient.getPacientById(req.params.id, function(err, pacient) {
        if(err) {
            throw err;
        }
        console.log(pacient);
        res.json(pacient);
    })
});

/*
UPDATE PACIENT DATA ENDPOINT
*/
app.put('/api/:id/user_profile',function(req,res){
    var id = req.params.id;
    var pacient = req.body;
    Pacient.updatePacient(id, pacient, {},function(err, pacient){
        if(err) {
            throw err;
        }
        
        res.json(pacient)
    });
});

/*
ADD PACIENT TO WAITLIST
*/
app.post('/api/add_user_waitlist',function(req,res){
    console.log(req.body);
    var pacient = req.body;
    Pacient.getPacientById(pacient._id, function(err, pacientR) {
        if(err) {
            throw err;
        }
        
        var pacientWait = {
            _id:pacient._id,
            name:pacientR.name
        }
            Wait.addToWaitList(pacientWait, function(err, pacient){
                if(err) {
                    throw err;
                        }   
                res.json(pacient)
        });  
    })
});

/*
SCHEDULE APPOINTMENT endpoint
*/
app.post('/api/schedule_appointment',function(req,res){
    var appointment = req.body;
    Appointment.addAppointment(appointment, function(err, appointment){
        if(err) {
            throw err;
        }
        
        res.json(appointment)
    });
});

/*
GET SCHEDULED APPOINTMENTS BY PACIENT
*/
app.get('/api/:id/scheduled_appointments',function(req,res){
    Appointment.getAppointmentByPacient(req.params.id, function(err, appointment) {
        if(err) {
            throw err;
        }
        console.log(appointment);
        res.json({appointments:appointment});
    })
});


app.get('/api/pacients',function(req,res){
    Pacient.getPacients(function(err,pacients){
        if(err) {
            throw err;
        }
        
        res.json(pacients)
    })
});

/*
REMOVE PACIENT FROM WAIT LIST
*/
app.post('/api/remove_user_waitlist',function(req,res){
    var item = {name:req.body.name}
    Wait.removeFromWaitList(item, function(err,result){
        if(err) {
            throw err;
        }
        res.json({
	           "result": "ok"
        });
    })
});


app.post('/api/rate',function(req,res){
    var rate = req.body;
    Rate.addToRate(rate, function(err, rate){
        if(err) {
            throw err;
        }
        
        res.json(rate)
    });
});
/*
****************************************************
END PACIENT ENDPOINTS
****************************************************
*/

//app.listen(4000);
app.listen(process.env.PORT || 4000)
console.log('running on port 4000...')